var chunkSize = 100;
var currentArgs;

function encode(input) {
	if (input!=null) {
		return input.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
	}
	else return '';
}


// load now playing
var nowPlaying = -1;
function loadNowPlaying() {
	$.ajax({  
        url: "info/nowplaying",    
        type: "GET",            
        cache: false,  
        success: function (data) { 
		    if (nowPlaying !=data[0].id) {
			    setNowPlaying(data[0], false);
			    nowPlaying = data[0].id;
		    } 
        },
		dataType: "json"
    });  
}


function setNowPlaying(now) {
	
	// get variables
	var nowTitle = $('#now_title');
	var nowArtist = $('#now_artist');
	var nowAlbumName = $('#now_album');
	var nowImage = $('#now_image');
	
	 //set the current song
    nowTitle.html(encode(now.name));
    nowArtist.html(encode(now.artistName));
    if(now.albumName=="Unknown")
    {
    nowAlbumName.html("");
    } else {
    nowAlbumName.html(encode(now.albumName));
    }
    nowImage.css("background-image",'url(/music/cover?song_id=' + now.id + ')');
}

// load the toplist
function loadTopList() {
	var toplist = $('#toplist');
	$.ajax({  
        url: "info/toplist",    
        type: "GET",            
        cache: false,  
        success: function (jsonObject) { 
			toplist.html('');
			if (jsonObject.data.length >0 ) {
			$.each(jsonObject.data, function() { 
			  toplist.append(
				'<li class=\"store\">' +
				'<a class="noeffect" href="songs.html?song_id=' + this.id + '">' +
				'<span class="image" style="background-image: url(note.png)"></span>' +
				'<span class="comment" >' + encode(this.artistName) + '</span>' +
				'<span class="name">' + encode(this.name) + '</span>' +
				'<span class="starcomment">Votes: ' + this.votes + '</span>' +
				'<span class="arrow"></span></a></li>');
			});
			} else {
				 toplist.append(
				'<li class=\"store\"><a href="libsongs.html">' +
				'<span class="image" style="background-image: url(note.png)"></span>' +
				'<span class="name">Jetzt abstimmen !</span>' +
				'</a></li>');
			}
		},
		dataType: "json"
    });  
}

function loadSong(id) {
	$.ajax({  
        url:'music/songs?song_id=' + id,    
        type: 'GET',            
        cache: true,  
        success: function (jsonObject) {   
			var song = jsonObject.data[0];
            $('#title').html(song.name); 
            $('#song').attr("value",song.name);
            $('#artist').attr("value",song.artistName);
            $('#artistsearch').attr("href",'libsongs.html?search='+encode(song.artistName));
            $('#album').attr("value",song.albumName);
            $('#votes').attr("value",song.votes);
            $('#cover').attr("src",'/music/cover?song_id=' + song.id);
        },
		dataType: 'json'
    });  
	
	
	
}

//Read a page's GET URL variables and return them as an associative array.
function getUrlVars()
{
    var vars = [], hash;
    var hashes = decodeURI(window.location.href.slice(window.location.href.indexOf('?') + 1)).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function vote(songID) {
	 //use ajax to vote
	 $.post('/login', { }, function(data){
	 	if (data.status!='OK') {
	 		$('#result').html(data.answer);
	 	} else {
	 	    $.post('music/vote', { song_id: songID },  
      			function(data){  
           if (data.answer=='OK') {
        	   $('#result').html('');
        	   window.location.href = 'home.html?vote='+data.answer;
           } else if (data.answer=='MANY_VOTES') {
        	   var seconds = data.secondsToWait;
        	   var minutes = Math.floor(seconds / 60);
        	   seconds = seconds%60;
        	   if (seconds<10) {
        		   seconds = '0' + seconds;
        	   }
        	   var time = minutes + ":" + seconds;
        	   $('#result').html('You have no votes left. Please vote again in ' + time + ' minute(s).');
           } else if (data.answer=='TWO_VOTES') {
        	   $('#result').html('You have already voted for this song');
           } else if (data.answer=='NOT_LOGGED_IN') {
        	   $('#result').html('Your browser must support cookies.');
           } else {
        	   $('#result').html('An error occurred');
           }
    },'json');  
	 	}
	 }, 'json');
}

var artistsLoaded = 0;
var readyToLoadArtists = 1;
var maxArtistId = -1;


// load artists
function loadArtists() {
	if (readyToLoadArtists==1) {
		readyToLoadArtists = 0;
		var list = $('#list');
		var listend = $('#listend');
		var loadedNow = 0;
		var count = chunkSize + 1;
		$.ajax({  
	        url: 'music/artists?' + 'start=' + artistsLoaded + '&count=' + count + '&max_id=' + maxArtistId + '&' + currentArgs,    
	        type: 'GET',            
	        cache: true,  
	        success: function (jsonObject) { 
				if (artistsLoaded == 0) {
					list.html('');
				}
				listend.html('');
				if (maxArtistId == -1) {
					maxArtistId = jsonObject.maxId;
				}
				$.each(jsonObject.data, function() { 
					if (loadedNow < chunkSize) {
						artistsLoaded++;
						loadedNow++;
					  list.append(
						'<li>' +
						'<a class="noeffect" href="libalbums.html?artist_id=' + this.id + '&selector=' + encodeURI('Artist: ' + this.name) + '">' +
						'<span class="name">' + encode(this.name) + '</span><span class="arrow"></span>' +
						'</a></li>');
					} else {
						listend.append(
								'<li>' +
								'<a class="noeffect" href="javascript:loadArtists()">' +
								'<span class="name">' + 'LOADING MORE...' + '</span><span class="arrow"></span>' +
								'</a></li>');
						readyToLoadArtists = 1;
					}
				});
			},
			dataType: "json"
	    });
	}
}

function getScrollTop() {
    // if one of these values evaluates to false, this picks the other
    return (document.documentElement.scrollTop||document.body.scrollTop);
}


var albumsLoaded = 0;
var readyToLoadAlbums = 1;
var maxAlbumId = -1;


//load albums
function loadAlbums() {
	if (readyToLoadAlbums==1) {
		readyToLoadAlbums = 0;
		var list = $('#list');
		var listend = $('#listend');
		var loadedNow = 0;
		var count = chunkSize + 1;
		$.ajax({  
	        url: 'music/albums?start=' + albumsLoaded + '&count=' + count + '&max_id=' + maxAlbumId + '&' + currentArgs,    
	        type: 'GET',            
	        cache: true,  
	        success: function (jsonObject) { 
				if (albumsLoaded == 0) {
					list.html('');
				}
				listend.html('');
				if (maxAlbumId == -1) {
					maxAlbumId = jsonObject.maxId;
				}
				$.each(jsonObject.data, function() { 
					if (loadedNow < chunkSize) {
						albumsLoaded++;
						loadedNow++;
					  list.append(
						'<li>' +
						'<a class="noeffect" href="libsongs.html?album_id=' + this.id + '&selector=' + encodeURI('Album: ' + this.name)+ '">' +
						'<span class="name">' + encode(this.name) + '</span><span class="arrow"></span>' +
						'</a></li>');
					} else {
						listend.append(
								'<li>' +
								'<a class="noeffect" href="javascript:loadAlbums()">' +
								'<span class="name">' + 'LOADING MORE...' + '</span><span class="arrow"></span>' +
								'</a></li>');
						readyToLoadAlbums = 1;
					}
				});
			},
			dataType: "json"
	    });  
	}
}

var songsLoaded = 0;
var readyToLoadSongs = 1;
var maxSongId = -1;


//load songs
function loadSongs() {
	if (readyToLoadSongs == 1) {
		readyToLoadSongs = 0;
		var list = $('#list');
		var listend = $('#listend');
		var loadedNow = 0;
		var count = chunkSize + 1;
		$.ajax({  
	        url: 'music/songs?start=' + songsLoaded + "&count=" + count + '&max_id=' + maxSongId + '&' + currentArgs,    
	        type: 'GET',            
	        cache: true,  
	        success: function (jsonObject) { 
				if (songsLoaded == 0) {
					list.html('');
				}
				listend.html('');
				if (maxSongId == -1) {
					maxSongId = jsonObject.maxId;
				}
				$.each(jsonObject.data, function() { 
					if (loadedNow < chunkSize) {
						songsLoaded++;
						loadedNow++;
					  list.append(
						'<li>' +
						'<a class="noeffect" href="songs.html?song_id=' + this.id + '">' +
						'<div class="name"><span class="artist">' + encode(this.artistName) + '</span>' +
						'<span class="title">' + encode(this.name) + '</span><span class="arrow"></span></div>' +
						'</a></li>');
					} else {
						listend.append(
								'<li>' +
								'<a class="noeffect" href="javascript:loadSongs()">' +
								'<span class="name">' + 'LOADING MORE...' + '</span><span class="arrow"></span>' +
								'</a></li>');
						readyToLoadSongs = 1;
					}
						
				});
			},
			dataType: "json"
	    });  
	}
}

//load songs
function searchSong(searchval) {
		var list = $('#list');
		var listend = $('#listend');
		var loadedNow = 0;
		var count = chunkSize + 1;
		$.ajax({  
	        url: 'music/searchsong?search=' + searchval,    
	        type: 'GET',            
	        cache: true,  
	        success: function (jsonObject) { 
				list.html('');
				listend.html('');
				if (maxSongId == -1) {
					maxSongId = jsonObject.maxId;
				}
				$.each(jsonObject.data, function() { 
						songsLoaded++;
						loadedNow++;
					  list.append(
						'<li>' +
						'<a class="noeffect" href="songs.html?song_id=' + this.id + '">' +
						'<div class="name"><span class="artist">' + encode(this.artistName) + '</span>' +
						'<span class="title">' + encode(this.name) + '</span><span class="arrow"></span></div>' +
						'</a></li>');
						
				});
			},
			dataType: "json"
	    });  
}
